/*
  Connections:
  ------------
  SD Card | ESP32
    D3       SS
    CMD      MOSI
    VSS      GND
    VDD      3.3V
    CLK      SCK
    VSS      GND
    D0       MISO
*/


// Enable debug prints to serial monitor
#define MY_DEBUG

// Enables and select radio type (if attached)
#define MY_RADIO_RF24
//#define MY_RADIO_RFM69
//#define MY_RADIO_RFM95

#define MY_RF24_CE_PIN 4
#define MY_RF24_CS_PIN 5


#define MY_GATEWAY_ESP32


#define MY_WIFI_SSID "mega"
#define MY_WIFI_PASSWORD "11111111"

// Set the hostname for the WiFi Client. This is the hostname
// it will pass to the DHCP server if not static.
#define MY_HOSTNAME "ESP32_GW"

// Enable MY_IP_ADDRESS here if you want a static ip address (no DHCP)
#define MY_IP_ADDRESS 192, 168, 2, 122

// If using static ip you can define Gateway and Subnet address as well
#define MY_IP_GATEWAY_ADDRESS 192, 168, 2, 100
#define MY_IP_SUBNET_ADDRESS 255, 255, 255, 0

// The port to keep open on node server mode
#define MY_PORT 5003

// How many clients should be able to connect to this gateway (default 1)
#define MY_GATEWAY_MAX_CLIENTS 2

#define CHILD_ID 1


float noda133temp = 0;
float noda133hum = 0;


bool releSt = 0; // вот на это может ругаться, что переменная не объявлена
String spisok = ""; // 
// modules
#define FEATURE_UPLOAD
#define FEATURE_TIME
#define FEATURE_NTP
#define FEATURE_SEND
#define FEATURE_MAJOR
#define FEATURE_KEYS
//#define FEATURE_BME
#define HTTP_FEATURE


// debug

#define SERIAL_PRINT

#include <pgmspace.h>

//#include "SPI.h"
#include "FS.h"
#include "SPIFFS.h"

#include <WiFi.h>
#include <TimeLib.h>

//#include <Wire.h> 
//#include <LiquidCrystal_I2C.h>

//LiquidCrystal_I2C lcd(0x27,20,4);//set the LCD address to 0x27 for a 16 chars and 2 line display


#include <MySensors.h>


MyMessage msg(CHILD_ID, V_TEXT);

#define SELF_NAME F("ESP32_MSG")
byte SELF_IP[] = {192, 168, 2, 122};

// Authorization
#define AUTH_OFF 0
#define AUTH_ON  1
byte authMode = AUTH_OFF;
// online encode: base64encode.org
String AUTH_HASH = "Authorization: Basic YWRtaW46YW1z"; // admin:ams

// time provider
#define TIME_NONE     0
#define TIME_NETWORK  1
#define TIME_RTC      2
byte timeProvider = TIME_NETWORK;

// mode work
#define MODE_SERVER   1
#define MODE_UPDATE   2
byte modeWork = MODE_SERVER;

// duration
time_t prevEventElectroCycle;
time_t prevEventEspLive;
time_t prevEventRequest;


// время апдейта

  unsigned long lpTempOldUpdate  = 0;
  unsigned long lpTempUpdate  = 0;

  unsigned long lpContOldUpdate  = 0;
  unsigned long lpContUpdate  = 0; 

  unsigned long lpTemp1OldUpdate  = 0;
  unsigned long lpTemp1Update  = 0; 

  unsigned long lpTemp2OldUpdate  = 0;
  unsigned long lpTemp2Update  = 0;     
//

// modules
#define DISABLE       0
#define ENABLE        1
#define NOT_COMPILLED 2
byte moduleUpload   = NOT_COMPILLED;
byte moduleTime     = NOT_COMPILLED;
byte moduleNtp      = NOT_COMPILLED;
byte moduleEthernet = NOT_COMPILLED;
byte moduleSd       = NOT_COMPILLED;
byte moduleServer   = NOT_COMPILLED;
byte moduleSend     = NOT_COMPILLED;
byte moduleMajor    = NOT_COMPILLED;
byte modulePing     = NOT_COMPILLED;
byte modulePirs     = NOT_COMPILLED;
byte moduleContacts = NOT_COMPILLED;
byte moduleTemp     = NOT_COMPILLED;
byte moduleLeds     = NOT_COMPILLED; 
byte moduleKeys     = NOT_COMPILLED;
byte moduleElectro  = NOT_COMPILLED;
byte moduleNoo      = NOT_COMPILLED;
byte moduleMr1132   = NOT_COMPILLED;
byte moduleNrf24    = NOT_COMPILLED;

byte moduleRobotdyn = NOT_COMPILLED;

byte moduleDHT      = NOT_COMPILLED;

byte moduleTlog     = NOT_COMPILLED;

byte moduleTwundergr = NOT_COMPILLED;

byte moduleBME       = NOT_COMPILLED;

byte moduleHTTP      = NOT_COMPILLED;//=====================



// timers
boolean cycle1s  = false;
boolean cycle5s  = false;
boolean cycle10s = false;
boolean cycle20s = false;
boolean cycle30s = false;
boolean cycle1m  = false;
boolean cycle3m  = false;
boolean cycle5m  = false;
boolean cycle15m = false; // добавил таймера
boolean cycle30m = false;
boolean cycle1h  = false;
boolean cycle1d  = false;
boolean cycle7d  = false;
boolean cycle30d = false; // добавил таймера

// strings
char buf[200];

// cyclos
unsigned long cyclos = 0;

#ifdef FEATURE_LEDS
  #define LED_EMPTY 0
  #define LED_PIR 1
  byte modeLed = LED_EMPTY;
#endif


//LiquidCrystal_I2C lcd(0x27,20,4);//set the LCD address to 0x27 for a 16 chars and 2 line display

void install() {

}

void receive(const MyMessage &message)
{
  if (message.type ==  V_STATUS) {
//    state = message.getBool();
 }

  // получаем сразу все данные из строки ДЕБАГА и разбираем её )))

  Serial.println("message");
  Serial.print("sensor: ");
  Serial.println(message.sensor);
  Serial.print("type: ");
  Serial.println(message.type);
  Serial.print("getBool(): ");
  Serial.println(message.getBool());
  Serial.print("getByte(): ");
  Serial.println(message.getByte());
  Serial.print("getString(): ");
  Serial.println(message.getString());

  
 // Serial.println(message.getCustomString());
 // Serial.println(message.getStream());
 // Serial.println(message.getCustom());
  Serial.println(message.getFloat());
  Serial.println(message.getInt());
  Serial.println(message.getLong());
  Serial.print("getCommand(): ");
  Serial.println(message.getCommand());
  Serial.print("getSensor(): ");
  Serial.println(message.getSensor());
  Serial.print("getSender(): ");
  Serial.println(message.getSender());
  Serial.print("getDestination(): ");
  Serial.println(message.getDestination());
  Serial.print("getHeaderSize(): ");
  Serial.println(message.getHeaderSize());
  Serial.print("getPayloadType(): ");
  Serial.println(message.getPayloadType());
  Serial.print("getLength(): ");
  Serial.println(message.getLength());
  Serial.print("getExpectedMessageSize(): ");
  Serial.println(message.getExpectedMessageSize());
  Serial.print("isProtocolVersionValid(): ");
  Serial.println(message.isProtocolVersionValid());
  Serial.print("getLast(): ");
  Serial.println(message.getLast());
  Serial.print("isEcho(): ");
  Serial.println(message.isEcho());
  Serial.print("getRequestEcho(): ");
  Serial.println(message.getRequestEcho());
  Serial.print("getVersion(): ");
  Serial.println(message.getVersion());
  Serial.print("getSigned(): ");
  Serial.println(message.getSigned());
//
//
 // getSensor(): 1
//  getSender(): 0
//  getDestination(): 133

    if ((message.getSensor() == 1) && (message.getSender() == 133)) {
    noda133temp = message.getFloat();
//===============================
   lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
         Serial.print(F("Update: ")); Serial.println(lpTempUpdate);
   lpTempOldUpdate = millis();
 //================================  
  }

      if ((message.getSensor() == 2) && (message.getSender() == 133)) {
    noda133hum = message.getFloat();
  }

// отправляем на ноду подтверждение, что получили данные и шлем её ответ ))) сразу )))

//  if ((message.getCommand() == 1) && (message.getSender() == 0) && (message.getSensor() == 1) && (message.getDestination() == 22)) {
//    //Confirmation_Answer_Accepted = 1;
//    //sleep_CHANGE = 0;
//    Serial.println(message.getString()); 
//    Serial.println("data for Sensor 22"); 
//    String str = message.getString();
//    str.trim();
//    Serial.println(message.getString()); 
//    if (str == "HIGH") {
//      //s = send(msg.setDestination(0).set("LOW")); 
//      send(msg.setDestination(22).set("Close")); 
//      Serial.println(message.getString()); 
//    }
//    if (str == "LOW") {
//      send(msg.setDestination(22).set("Open")); 
//      Serial.println(message.getString()); 
//    }
//  }  
}

void setup() {

  initSerial();
  printWelcome();
  initSpiffs();
  initRandom();
  install();
  initEeprom();
  initAbstract();
  initHardware();
  initTimers();
  initWifi();
  initNtp();
  initTime();
  
  initServer();

  #ifdef FEATURE_UPLOAD
    initUpload();
  #endif
  #ifdef FEATURE_SEND
    initSend();
  #endif
  #ifdef FEATURE_MAJOR
    initMajordomo();

    majordomoEspLive();
  #endif
  #ifdef FEATURE_TEMP
    initTemp();
  #endif
  #ifdef FEATURE_CONTACTS
    initContacts();
  #endif
  #ifdef FEATURE_PIRS
    initPirs();
  #endif
  #ifdef FEATURE_LEDS
    initLeds();
  #endif
  #ifdef FEATURE_KEYS
    initKeys();
  #endif

  #ifdef ROBOTDYN_FEATURE
    initRobotdyn();
  #endif

  #ifdef FEATURE_DHT
    initDHT();
  #endif

  //==================
  #ifdef FEATURE_MYSEN
    initMYSEN();
  #endif
  //=====================

    #ifdef FEATURE_BME
    Initbme();
  #endif


  #ifdef FEATURE_NRF24
    InitNrf24();
  #endif
  
  #ifdef FEATURE_ELECTRO
    initElectro();
  #endif
  

 #ifdef FEATURE_TLOG
    initTlog();
  #endif

  #ifdef FEATURE_WUNDERGR
    initTwundergr();
  #endif

  #ifdef HTTP_FEATURE
    initHttp();
  #endif
 
  printInitDone();
/*
  lcd.begin();// initialize the lcd with SDA and SCL pins
  
  // Print a message to the LCD.
  
  lcd.backlight();
 // lcd.clear();

  // Print a message to the LCD.
  
  lcd.setCursor(0,0);
  lcd.print("AMS_ESP32 V_0.17");

  lcd.setCursor(0,1);
  lcd.print("TIME");

  lcd.setCursor(8,1);
  lcd.print(":");

  lcd.setCursor(14,1);
  lcd.print(":");

  lcd.setCursor(17,1);
  lcd.print(":");  

  lcd.setCursor(0,2);
  lcd.print("Self_Temp");

  lcd.setCursor(0,3);
  lcd.print("UP_Time");
 */

  
  //testInit();
  
} // setup

void loop() {

  
  #ifdef FEATURE_UPLOAD
    workUpload();
  #endif

  if (modeWork == MODE_SERVER) {
    workTimers();
    workTime();
    workServer();
  
    #ifdef FEATURE_TEMP
      workTemp();
    #endif
    #ifdef FEATURE_CONTACTS
      workContacts();
    #endif
    #ifdef FEATURE_PIRS
      workPirs();
    #endif
    #ifdef FEATURE_KEYS
      workKeys();
    #endif

    #ifdef FEATURE_DHT
      workDHT();
    #endif

   //====================
/*
  #ifdef FEATURE_MYSEN
  
    //workMYSEN();

    if (cycle5s) {
      workMYSEN();
    }
    
    
    if (cycle5s) {
        lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
        lpContUpdate = (millis() - lpContOldUpdate) / 1000;
        lpTemp1Update =(millis() - lpTemp1OldUpdate) / 1000;
        lpTemp2Update =(millis() - lpTemp2OldUpdate) / 1000;

   }

    if (cycle1m) {
      statusGate();
    }
  #endif
  */
  //===================    

    #ifdef FEATURE_MAJOR
      majordomoEspLive();
    #endif


    #ifdef FEATURE_NRF24
     
         WorksNrf24();

      if (timer1(1000, 9000)) {
        carousel();
      }
    #endif
    
     #ifdef FEATURE_ELECTRO

     /*
     if (cycle20s) {
      workElectro();
     }
     */

       if (moduleElectro == 1) {
        if (cycle20s) {
          workElectro();
          freqWorks();
        }
        // network oscilloscope
        if (cycle1s && oscill) {
          freqWorks();
        }
      }
    #endif

        #ifdef FEATURE_BME

    if (cycle20s) {
      bmeWorks();
    }
    #endif

 

  #ifdef ROBOTDYN_FEATURE
    workRobotdyn();
  #endif

   #ifdef FEATURE_TLOG
    workTlog();
  #endif

  #ifdef FEATURE_WUNDERGR
   workTwundergr();
  #endif

    #ifdef HTTP_FEATURE
     httpWork();
    #endif

        if (cycle5s) {
        lpTempUpdate = (millis() - lpTempOldUpdate) / 1000;
        lpContUpdate = (millis() - lpContOldUpdate) / 1000;
        lpTemp1Update =(millis() - lpTemp1OldUpdate)/ 1000;
        lpTemp2Update =(millis() - lpTemp2OldUpdate)/ 1000;

   }

    workAbstract();
    workLoopEnd();

//    if (cycle5m) {
//      testRele();
//    }

        //==========================

 //if (cycle5s) {
/*
        lcd.setCursor(6, 1);//
        lcd.print(day());//

        lcd.setCursor(10, 1);//
        lcd.print(month());// 

        lcd.setCursor(12, 1);//
        lcd.print(hour());// 

        lcd.setCursor(15, 1);//
        lcd.print(minute());//

        lcd.setCursor(18, 1);// 
        lcd.print(second());//




        lcd.setCursor(10, 3);
        lcd.print(uptimeString());

 //}




*/
        
  } // MODE_SERVER


} // loop

